/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "bonobo.override"

#include <Python.h>
#define NO_IMPORT_PYGOBJECT
#include <pygobject.h>
#include <pyorbit.h>
#include <libbonobo.h>
#include <bonobo/bonobo-persist-client.h>
#include <bonobo/bonobo-item-handler.h>
#line 17 "bonobo.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyBonoboObject_Type;
PyTypeObject PyBonoboGenericFactory_Type;
PyTypeObject PyBonoboItemHandler_Type;
PyTypeObject PyBonoboListener_Type;
PyTypeObject PyBonoboMoniker_Type;
PyTypeObject PyBonoboMonikerSimple_Type;
PyTypeObject PyBonoboPersist_Type;
PyTypeObject PyBonoboPersistFile_Type;
PyTypeObject PyBonoboPersistStream_Type;
PyTypeObject PyBonoboPropertyBag_Type;
PyTypeObject PyBonoboStreamMem_Type;


/* ----------- BonoboObject ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_bonobo_object_add_interface(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "newobj", NULL };
    PyGObject *newobj;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboObject.add_interface", kwlist, &PyBonoboObject_Type, &newobj))
        return NULL;
    bonobo_object_add_interface(BONOBO_OBJECT(self->obj), BONOBO_OBJECT(newobj->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_query_local_interface(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "repo_id", NULL };
    char *repo_id;
    BonoboObject *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboObject.query_local_interface", kwlist, &repo_id))
        return NULL;
    ret = bonobo_object_query_local_interface(BONOBO_OBJECT(self->obj), repo_id);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_object_query_interface(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "repo_id", NULL };
    char *repo_id;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboObject.query_interface", kwlist, &repo_id))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_object_query_interface(BONOBO_OBJECT(self->obj), repo_id, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_corba_objref(PyGObject *self)
{
    Bonobo_Unknown ret;

    ret = bonobo_object_corba_objref(BONOBO_OBJECT(self->obj));
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_idle_unref(PyGObject *self)
{
    bonobo_object_idle_unref(BONOBO_OBJECT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_set_immortal(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "immortal", NULL };
    int immortal;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboObject.set_immortal", kwlist, &immortal))
        return NULL;
    bonobo_object_set_immortal(BONOBO_OBJECT(self->obj), immortal);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_dump_interfaces(PyGObject *self)
{
    bonobo_object_dump_interfaces(BONOBO_OBJECT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_check_env(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "corba_object", NULL };
    PyObject *corba_object;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboObject.check_env", kwlist, &PyCORBA_Object_Type, &corba_object))
        return NULL;
    CORBA_exception_init(&ev);
    bonobo_object_check_env(BONOBO_OBJECT(self->obj), (CORBA_Object)((PyCORBA_Object *)corba_object)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboObject_methods[] = {
    { "add_interface", (PyCFunction)_wrap_bonobo_object_add_interface, METH_VARARGS|METH_KEYWORDS },
    { "query_local_interface", (PyCFunction)_wrap_bonobo_object_query_local_interface, METH_VARARGS|METH_KEYWORDS },
    { "query_interface", (PyCFunction)_wrap_bonobo_object_query_interface, METH_VARARGS|METH_KEYWORDS },
    { "corba_objref", (PyCFunction)_wrap_bonobo_object_corba_objref, METH_NOARGS },
    { "idle_unref", (PyCFunction)_wrap_bonobo_object_idle_unref, METH_NOARGS },
    { "set_immortal", (PyCFunction)_wrap_bonobo_object_set_immortal, METH_VARARGS|METH_KEYWORDS },
    { "dump_interfaces", (PyCFunction)_wrap_bonobo_object_dump_interfaces, METH_NOARGS },
    { "check_env", (PyCFunction)_wrap_bonobo_object_check_env, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboObject_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.Object",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboObject_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboGenericFactory ----------- */

#line 36 "bonobo.override"
static int
_wrap_bonobo_generic_factory_new_closure (PyGObject * self,
					  PyObject *  args,
					  PyObject * kwargs)
{
    static char *kwlist[] = { "act_iid", "func", "extra_data", NULL };
    gchar *act_iid;
    PyObject *callback;
    PyObject *params = NULL;
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "sO|O:BonoboGenericFactory.__init__",
				     kwlist, &act_iid, &callback, &params)) {
        return -1;
    }

    if (!PyCallable_Check (callback)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return -1;
    }

    self->obj = (GObject*)bonobo_generic_factory_new_closure (act_iid,
                                 pyg_closure_new (callback, params, NULL));
    if (!self->obj) {
	PyErr_SetString(PyExc_RuntimeError,
			"could not create BonoboGenericFactory");
	return -1;
    }
    pygobject_register_wrapper ((PyObject *)self);
    return 0;
}
#line 245 "bonobo.c"


PyTypeObject PyBonoboGenericFactory_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.GenericFactory",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_generic_factory_new_closure,		/* tp_init */
};



/* ----------- BonoboItemHandler ----------- */

#line 206 "bonobo.override"
static int
_wrap_bonobo_item_handler_new_closure (PyGObject * self,
			           PyObject *  args,
				   PyObject * kwargs)
{
    static char *kwlist[] = { "enum_objects", "get_objects", "extra_data", NULL };
    PyObject *enum_objects_cb;
    PyObject *get_objects_cb;    
    PyObject *params = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "OO|O:BonoboItemHandler.__init__",
				     kwlist, &enum_objects_cb, &get_objects_cb, &params)) {
        return -1;
    }

    if (!PyCallable_Check (enum_objects_cb)) {
        PyErr_SetString (PyExc_TypeError, "first arg not callable");
	return -1;
    }
    
    if (!PyCallable_Check (get_objects_cb)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return -1;
    }    

    self->obj = (GObject*)bonobo_item_handler_new_closure (
                          pyg_closure_new (enum_objects_cb, params, NULL),
                          pyg_closure_new (get_objects_cb, params, NULL));
    if (!self->obj) {
	PyErr_SetString(PyExc_RuntimeError,
			"could not create BonoboItemHandler");
	return -1;
    }
    pygobject_register_wrapper ((PyObject *)self);
    
    return 0;
}
#line 332 "bonobo.c"


PyTypeObject PyBonoboItemHandler_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.ItemHandler",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_item_handler_new_closure,		/* tp_init */
};



/* ----------- BonoboListener ----------- */

#line 103 "bonobo.override"
static int
_wrap_bonobo_listener_new_closure (PyGObject * self,
			           PyObject *  args,
				   PyObject * kwargs)
{
    static char *kwlist[] = { "func", "extra_data", NULL };
    PyObject *callback;
    PyObject *params = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "O|O:BonoboListener.__init__",
				     kwlist, &callback, &params)) {
        return -1;
    }

    if (!PyCallable_Check (callback)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return -1;
    }

    self->obj = (GObject*)bonobo_listener_new_closure (pyg_closure_new (callback, params, NULL));
    if (!self->obj) {
	PyErr_SetString(PyExc_RuntimeError,
			"could not create BonoboListener");
	return -1;
    }
    pygobject_register_wrapper ((PyObject *)self);
    
    return 0; 
}
#line 411 "bonobo.c"


PyTypeObject PyBonoboListener_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.Listener",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_listener_new_closure,		/* tp_init */
};



/* ----------- BonoboMoniker ----------- */

#line 69 "bonobo.override"
static int
_wrap_bonobo_moniker_simple_new_closure (PyGObject * self,
					  PyObject *  args,
					  PyObject * kwargs)
{
    static char *kwlist[] = { "name", "func", "extra_data", NULL };
    gchar *name;
    PyObject *callback;
    PyObject *params = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "sO|O:BonoboMonikerSimple.__init__",
				     kwlist, &name, &callback, &params)) {
        return -1;
    }

    if (!PyCallable_Check (callback)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return -1;
    }

    self->obj = (GObject*)bonobo_moniker_simple_new_closure (name,
							     pyg_closure_new (callback, params, NULL));
    if (!self->obj) {
	PyErr_SetString(PyExc_RuntimeError,
			"could not create BonoboMonikerSimple");
	return -1;
    }
    pygobject_register_wrapper ((PyObject *)self);
    
    return 0;
}
#line 492 "bonobo.c"


static PyObject *
_wrap_bonobo_moniker_get_parent(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_Moniker ret;

    CORBA_exception_init(&opt_ev);
    ret = bonobo_moniker_get_parent(BONOBO_MONIKER(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_set_parent(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "parent", NULL };
    PyObject *parent;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:BonoboMoniker.set_parent", kwlist, &PyCORBA_Object_Type, &parent))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_moniker_set_parent(BONOBO_MONIKER(self->obj), (Bonobo_Moniker)((PyCORBA_Object *)parent)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_get_name(PyGObject *self)
{
    const gchar *ret;

    ret = bonobo_moniker_get_name(BONOBO_MONIKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_get_name_full(PyGObject *self)
{
    const gchar *ret;

    ret = bonobo_moniker_get_name_full(BONOBO_MONIKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_get_name_escaped(PyGObject *self)
{
    gchar *ret;

    ret = bonobo_moniker_get_name_escaped(BONOBO_MONIKER(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_set_name(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "unescaped_name", NULL };
    char *unescaped_name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboMoniker.set_name", kwlist, &unescaped_name))
        return NULL;
    bonobo_moniker_set_name(BONOBO_MONIKER(self->obj), unescaped_name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_get_prefix(PyGObject *self)
{
    const gchar *ret;

    ret = bonobo_moniker_get_prefix(BONOBO_MONIKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_set_case_sensitive(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "sensitive", NULL };
    int sensitive;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboMoniker.set_case_sensitive", kwlist, &sensitive))
        return NULL;
    bonobo_moniker_set_case_sensitive(BONOBO_MONIKER(self->obj), sensitive);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_get_case_sensitive(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_moniker_get_case_sensitive(BONOBO_MONIKER(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyMethodDef _PyBonoboMoniker_methods[] = {
    { "get_parent", (PyCFunction)_wrap_bonobo_moniker_get_parent, METH_NOARGS },
    { "set_parent", (PyCFunction)_wrap_bonobo_moniker_set_parent, METH_VARARGS|METH_KEYWORDS },
    { "get_name", (PyCFunction)_wrap_bonobo_moniker_get_name, METH_NOARGS },
    { "get_name_full", (PyCFunction)_wrap_bonobo_moniker_get_name_full, METH_NOARGS },
    { "get_name_escaped", (PyCFunction)_wrap_bonobo_moniker_get_name_escaped, METH_NOARGS },
    { "set_name", (PyCFunction)_wrap_bonobo_moniker_set_name, METH_VARARGS|METH_KEYWORDS },
    { "get_prefix", (PyCFunction)_wrap_bonobo_moniker_get_prefix, METH_NOARGS },
    { "set_case_sensitive", (PyCFunction)_wrap_bonobo_moniker_set_case_sensitive, METH_VARARGS|METH_KEYWORDS },
    { "get_case_sensitive", (PyCFunction)_wrap_bonobo_moniker_get_case_sensitive, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboMoniker_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.Moniker",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboMoniker_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_moniker_simple_new_closure,		/* tp_init */
};



/* ----------- BonoboMonikerSimple ----------- */

PyTypeObject PyBonoboMonikerSimple_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.MonikerSimple",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboPersist ----------- */

static PyObject *
_wrap_bonobo_persist_set_dirty(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dirty", NULL };
    int dirty;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:BonoboPersist.set_dirty", kwlist, &dirty))
        return NULL;
    bonobo_persist_set_dirty(BONOBO_PERSIST(self->obj), dirty);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboPersist_methods[] = {
    { "set_dirty", (PyCFunction)_wrap_bonobo_persist_set_dirty, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboPersist_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.Persist",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboPersist_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboPersistFile ----------- */

PyTypeObject PyBonoboPersistFile_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.PersistFile",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboPersistStream ----------- */

PyTypeObject PyBonoboPersistStream_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.PersistStream",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- BonoboPropertyBag ----------- */

#line 135 "bonobo.override"
static int
_wrap_bonobo_property_bag_new_closure (PyGObject * self,
			           PyObject *  args,
				   PyObject * kwargs)
{
    static char *kwlist[] = { "get_prop", "set_prop", "extra_data", NULL };
    PyObject *get_prop_cb;
    PyObject *set_prop_cb;    
    PyObject *params = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "OO|O:BonoboPropertyBag.__init__",
				     kwlist, &get_prop_cb, &set_prop_cb, &params)) {
        return -1;
    }

    if (!PyCallable_Check (get_prop_cb)) {
        PyErr_SetString (PyExc_TypeError, "first arg not callable");
	return -1;
    }
    
    if (!PyCallable_Check (set_prop_cb)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return -1;
    }    

    self->obj = (GObject*)bonobo_property_bag_new_closure (
                          pyg_closure_new (get_prop_cb, params, NULL),
                          pyg_closure_new (set_prop_cb, params, NULL));
    if (!self->obj) {
	PyErr_SetString(PyExc_RuntimeError,
			"could not create BonoboPropertyBag");
	return -1;
    }
    pygobject_register_wrapper ((PyObject *)self);
    
    return 0;
}
#line 912 "bonobo.c"


static PyObject *
_wrap_bonobo_property_bag_remove(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:BonoboPropertyBag.remove", kwlist, &name))
        return NULL;
    bonobo_property_bag_remove(BONOBO_PROPERTY_BAG(self->obj), name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboPropertyBag_methods[] = {
    { "remove", (PyCFunction)_wrap_bonobo_property_bag_remove, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboPropertyBag_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.PropertyBag",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboPropertyBag_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_bonobo_property_bag_new_closure,		/* tp_init */
};



/* ----------- BonoboStreamMem ----------- */

static PyObject *
_wrap_bonobo_stream_mem_get_buffer(PyGObject *self)
{
    const gchar *ret;

    ret = bonobo_stream_mem_get_buffer(BONOBO_STREAM_MEM(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyBonoboStreamMem_methods[] = {
    { "get_buffer", (PyCFunction)_wrap_bonobo_stream_mem_get_buffer, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyBonoboStreamMem_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "bonobo.StreamMem",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyBonoboStreamMem_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_bonobo_context_add(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "context_name", "context", NULL };
    char *context_name;
    PyObject *context;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:context_add", kwlist, &context_name, &PyCORBA_Object_Type, &context))
        return NULL;
    bonobo_context_add(context_name, (Bonobo_Unknown)((PyCORBA_Object *)context)->objref);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_context_running_get(PyObject *self)
{
    BonoboObject *ret;

    ret = bonobo_context_running_get();
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_running_context_auto_exit_unref(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", NULL };
    PyGObject *object;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:running_context_auto_exit_unref", kwlist, &PyBonoboObject_Type, &object))
        return NULL;
    bonobo_running_context_auto_exit_unref(BONOBO_OBJECT(object->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_event_source_client_remove_listener(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", "listener", NULL };
    PyObject *object, *listener;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:event_source_client_remove_listener", kwlist, &PyCORBA_Object_Type, &object, &PyCORBA_Object_Type, &listener))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_event_source_client_remove_listener((Bonobo_Unknown)((PyCORBA_Object *)object)->objref, (Bonobo_Listener)((PyCORBA_Object *)listener)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

#line 175 "bonobo.override"
static PyObject *
_wrap_bonobo_event_source_client_add_listener_closure (PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", "callback", "extra_data", "opt_mask", NULL };
    PyObject *object;
    PyObject *callback;
    gchar *opt_mask = NULL;
    PyObject *params = NULL;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, 
                                     "!OO|sO:BonoboObject.check_env", kwlist,
                                     &PyCORBA_Object_Type, &object, &callback,
				     &opt_mask, &params))
        return NULL;
	
    CORBA_exception_init(&ev);
    
    bonobo_event_source_client_add_listener_closure (((PyCORBA_Object *)object)->objref,
    						     pyg_closure_new (callback, params, NULL),
						     opt_mask,
						     &ev);

    if (pyorbit_check_ex(&ev))
	return NULL;
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 1124 "bonobo.c"


static PyObject *
_wrap_bonobo_exception_repoid_to_text(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "repo_id", NULL };
    char *repo_id;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:exception_repoid_to_text", kwlist, &repo_id))
        return NULL;
    ret = bonobo_exception_repoid_to_text(repo_id);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_exception_add_handler_str(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "repo_id", "str", NULL };
    char *repo_id, *str;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:exception_add_handler_str", kwlist, &repo_id, &str))
        return NULL;
    bonobo_exception_add_handler_str(repo_id, str);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_exception_general_error_get(PyObject *self)
{
    CORBA_Environment ev;
    const gchar *ret;

    CORBA_exception_init(&ev);
    ret = bonobo_exception_general_error_get(&ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_event_make_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idl_path", "kind", "subtype", NULL };
    char *idl_path, *kind, *subtype;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sss:event_make_name", kwlist, &idl_path, &kind, &subtype))
        return NULL;
    ret = bonobo_event_make_name(idl_path, kind, subtype);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_event_type(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "event_name", NULL };
    char *event_name;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:event_type", kwlist, &event_name))
        return NULL;
    ret = bonobo_event_type(event_name);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_event_subtype(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "event_name", NULL };
    char *event_name;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:event_subtype", kwlist, &event_name))
        return NULL;
    ret = bonobo_event_subtype(event_name);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_event_kind(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "event_name", NULL };
    char *event_name;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:event_kind", kwlist, &event_name))
        return NULL;
    ret = bonobo_event_kind(event_name);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_event_idl_path(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "event_name", NULL };
    char *event_name;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:event_idl_path", kwlist, &event_name))
        return NULL;
    ret = bonobo_event_idl_path(event_name);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_debug_shutdown(PyObject *self)
{
    int ret;

    ret = bonobo_debug_shutdown();
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_main(PyObject *self)
{
    bonobo_main();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_main_quit(PyObject *self)
{
    bonobo_main_quit();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_activate(PyObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = bonobo_activate();
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_orb(PyObject *self)
{
    CORBA_ORB ret;

    ret = bonobo_orb();
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_orb_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_poa(PyObject *self)
{
    PortableServer_POA ret;

    ret = bonobo_poa();
    if (ret != CORBA_OBJECT_NIL)
        return pyorbit_poa_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_poa_manager(PyObject *self)
{
    PortableServer_POAManager ret;

    ret = bonobo_poa_manager();
    if (ret != CORBA_OBJECT_NIL)
        return pyorbit_poamanager_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_get_object(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "interface_name", NULL };
    char *name, *interface_name;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:get_object", kwlist, &name, &interface_name))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_get_object(name, interface_name, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_client_new_from_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;
    CORBA_Environment opt_ev;
    Bonobo_Moniker ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:moniker_client_new_from_name", kwlist, &name))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_moniker_client_new_from_name(name, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_client_get_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "moniker", NULL };
    PyObject *moniker;
    CORBA_Environment opt_ev;
    const gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:moniker_client_get_name", kwlist, &PyCORBA_Object_Type, &moniker))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_moniker_client_get_name((Bonobo_Moniker)((PyCORBA_Object *)moniker)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_client_resolve_default(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "moniker", "interface_name", NULL };
    PyObject *moniker;
    char *interface_name;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:moniker_client_resolve_default", kwlist, &PyCORBA_Object_Type, &moniker, &interface_name))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_moniker_client_resolve_default((Bonobo_Moniker)((PyCORBA_Object *)moniker)->objref, interface_name, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_client_equal(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "moniker", "name", NULL };
    PyObject *moniker, *py_ret;
    char *name;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:moniker_client_equal", kwlist, &PyCORBA_Object_Type, &moniker, &name))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_moniker_client_equal((Bonobo_Moniker)((PyCORBA_Object *)moniker)->objref, name, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_moniker_util_get_parent_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "moniker", NULL };
    PyObject *moniker;
    CORBA_Environment opt_ev;
    const gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:moniker_util_get_parent_name", kwlist, &PyCORBA_Object_Type, &moniker))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_moniker_util_get_parent_name((Bonobo_Moniker)((PyCORBA_Object *)moniker)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_util_qi_return(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", "requested_interface", NULL };
    PyObject *object;
    char *requested_interface;
    CORBA_Environment ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:moniker_util_qi_return", kwlist, &PyCORBA_Object_Type, &object, &requested_interface))
        return NULL;
    CORBA_exception_init(&ev);
    ret = bonobo_moniker_util_qi_return((Bonobo_Unknown)((PyCORBA_Object *)object)->objref, requested_interface, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_util_seek_std_separator(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "str", "min_idx", NULL };
    char *str;
    int min_idx, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:moniker_util_seek_std_separator", kwlist, &str, &min_idx))
        return NULL;
    ret = bonobo_moniker_util_seek_std_separator(str, min_idx);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_moniker_util_escape(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "string", "offset", NULL };
    char *string;
    int offset;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:moniker_util_escape", kwlist, &string, &offset))
        return NULL;
    ret = bonobo_moniker_util_escape(string, offset);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_moniker_util_unescape(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "string", "num_chars", NULL };
    char *string;
    int num_chars;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:moniker_util_unescape", kwlist, &string, &num_chars))
        return NULL;
    ret = bonobo_moniker_util_unescape(string, num_chars);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_url_register(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "oafiid", "url", "mime_type", "object", NULL };
    char *oafiid, *url, *mime_type;
    PyObject *object;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sssO!:url_register", kwlist, &oafiid, &url, &mime_type, &PyCORBA_Object_Type, &object))
        return NULL;
    CORBA_exception_init(&ev);
    bonobo_url_register(oafiid, url, mime_type, (Bonobo_Unknown)((PyCORBA_Object *)object)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_url_unregister(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "oafiid", "url", NULL };
    char *oafiid, *url;
    CORBA_Environment ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:url_unregister", kwlist, &oafiid, &url))
        return NULL;
    CORBA_exception_init(&ev);
    bonobo_url_unregister(oafiid, url, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_url_lookup(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "oafiid", "url", NULL };
    char *oafiid, *url;
    CORBA_Environment ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:url_lookup", kwlist, &oafiid, &url))
        return NULL;
    CORBA_exception_init(&ev);
    ret = bonobo_url_lookup(oafiid, url, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_dup_ref(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", NULL };
    PyObject *object;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:object_dup_ref", kwlist, &PyCORBA_Object_Type, &object))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_object_dup_ref((Bonobo_Unknown)((PyCORBA_Object *)object)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_release_unref(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", NULL };
    PyObject *object;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:object_release_unref", kwlist, &PyCORBA_Object_Type, &object))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_object_release_unref((Bonobo_Unknown)((PyCORBA_Object *)object)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_object_from_stream(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "stream", NULL };
    PyObject *stream;
    CORBA_Environment opt_ev;
    Bonobo_Unknown ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:object_from_stream", kwlist, &PyCORBA_Object_Type, &stream))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_object_from_stream((Bonobo_Stream)((PyCORBA_Object *)stream)->objref, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_get_string(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    gchar *ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_string", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_string((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_get_default_string(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    gchar *ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_string", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_string((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_get_short(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_short", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_short((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_short(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_short", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_short((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_ushort(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_ushort", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_ushort((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_ushort(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_ushort", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_ushort((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_long(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_long", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_long((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_long(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_long", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_long((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_ulong(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    gulong ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_ulong", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_ulong((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyLong_FromUnsignedLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_ulong(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    gulong ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_ulong", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_ulong((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyLong_FromUnsignedLong(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_float(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    double ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_float", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_float((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyFloat_FromDouble(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_float(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    double ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_float", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_float((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyFloat_FromDouble(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_double(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    double ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_double", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_double((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyFloat_FromDouble(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_double(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    double ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_double", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_double((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyFloat_FromDouble(ret);
}

static PyObject *
_wrap_bonobo_pbclient_get_boolean(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag, *py_ret;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_boolean", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_boolean((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_pbclient_get_default_boolean(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag, *py_ret;
    char *key;
    int ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_boolean", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_boolean((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_bonobo_pbclient_get_char(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    gchar ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_char", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_char((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyString_FromStringAndSize(&ret, 1);
}

static PyObject *
_wrap_bonobo_pbclient_get_default_char(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    gchar ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_default_char", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_char((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    return PyString_FromStringAndSize(&ret, 1);
}

static PyObject *
_wrap_bonobo_pbclient_get_value(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "opt_tc", NULL };
    PyObject *bag, *opt_tc;
    char *key;
    CORBA_Environment opt_ev;
    CORBA_any *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sO!:pbclient_get_value", kwlist, &PyCORBA_Object_Type, &bag, &key, &PyCORBA_TypeCode_Type, &opt_tc))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_value((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, ((PyCORBA_TypeCode *)opt_tc)->tc, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != NULL)
        return pycorba_any_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_get_default_value(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "opt_tc", NULL };
    PyObject *bag, *opt_tc;
    char *key;
    CORBA_Environment opt_ev;
    CORBA_any *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sO!:pbclient_get_default_value", kwlist, &PyCORBA_Object_Type, &bag, &key, &PyCORBA_TypeCode_Type, &opt_tc))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_default_value((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, ((PyCORBA_TypeCode *)opt_tc)->tc, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != NULL)
        return pycorba_any_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_string(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key, *value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!ss:pbclient_set_string", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_string((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_short(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key;
    int value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!si:pbclient_set_short", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_short((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_ushort(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key;
    int value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!si:pbclient_set_ushort", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_ushort((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_long(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key;
    int value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!si:pbclient_set_long", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_long((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_ulong(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag, *py_value = NULL;
    char *key;
    CORBA_Environment opt_ev;
    gulong value;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sO!:pbclient_set_ulong", kwlist, &PyCORBA_Object_Type, &bag, &key, &PyLong_Type, &py_value))
        return NULL;
    value = PyLong_AsUnsignedLong(py_value);
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_ulong((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_float(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    double value;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sd:pbclient_set_float", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_float((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_double(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key;
    CORBA_Environment opt_ev;
    double value;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sd:pbclient_set_double", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_double((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_boolean(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key;
    int value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!si:pbclient_set_boolean", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_boolean((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_char(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag;
    char *key, value;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sc:pbclient_set_char", kwlist, &PyCORBA_Object_Type, &bag, &key, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_char((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, value, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_set_value(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", "value", NULL };
    PyObject *bag, *value;
    char *key;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sO!:pbclient_set_value", kwlist, &PyCORBA_Object_Type, &bag, &key, &PyCORBA_Any_Type, &value))
        return NULL;
    CORBA_exception_init(&opt_ev);
    bonobo_pbclient_set_value((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &((PyCORBA_Any *)value)->any, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_get_doc_title(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    gchar *ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_doc_title", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_doc_title((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_pbclient_get_doc(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bag", "key", NULL };
    PyObject *bag;
    char *key;
    gchar *ret;
    CORBA_Environment opt_ev;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:pbclient_get_doc", kwlist, &PyCORBA_Object_Type, &bag, &key))
        return NULL;
    CORBA_exception_init(&opt_ev);
    ret = bonobo_pbclient_get_doc((Bonobo_PropertyBag)((PyCORBA_Object *)bag)->objref, key, &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_bonobo_storage_mem_create(PyObject *self)
{
    BonoboObject *ret;

    ret = bonobo_storage_mem_create();
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_bonobo_stream_client_get_length(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "stream", NULL };
    PyObject *stream;
    CORBA_Environment ev;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:stream_client_get_length", kwlist, &PyCORBA_Object_Type, &stream))
        return NULL;
    CORBA_exception_init(&ev);
    ret = bonobo_stream_client_get_length((const Bonobo_Stream)((PyCORBA_Object *)stream)->objref, &ev);
    if (pyorbit_check_ex(&ev))
        return NULL;
    return PyInt_FromLong(ret);
}

PyMethodDef pybonobo_functions[] = {
    { "context_add", (PyCFunction)_wrap_bonobo_context_add, METH_VARARGS|METH_KEYWORDS },
    { "context_running_get", (PyCFunction)_wrap_bonobo_context_running_get, METH_NOARGS },
    { "running_context_auto_exit_unref", (PyCFunction)_wrap_bonobo_running_context_auto_exit_unref, METH_VARARGS|METH_KEYWORDS },
    { "event_source_client_remove_listener", (PyCFunction)_wrap_bonobo_event_source_client_remove_listener, METH_VARARGS|METH_KEYWORDS },
    { "event_source_client_add_listener_closure", (PyCFunction)_wrap_bonobo_event_source_client_add_listener_closure, METH_VARARGS|METH_KEYWORDS },
    { "exception_repoid_to_text", (PyCFunction)_wrap_bonobo_exception_repoid_to_text, METH_VARARGS|METH_KEYWORDS },
    { "exception_add_handler_str", (PyCFunction)_wrap_bonobo_exception_add_handler_str, METH_VARARGS|METH_KEYWORDS },
    { "exception_general_error_get", (PyCFunction)_wrap_bonobo_exception_general_error_get, METH_NOARGS },
    { "event_make_name", (PyCFunction)_wrap_bonobo_event_make_name, METH_VARARGS|METH_KEYWORDS },
    { "event_type", (PyCFunction)_wrap_bonobo_event_type, METH_VARARGS|METH_KEYWORDS },
    { "event_subtype", (PyCFunction)_wrap_bonobo_event_subtype, METH_VARARGS|METH_KEYWORDS },
    { "event_kind", (PyCFunction)_wrap_bonobo_event_kind, METH_VARARGS|METH_KEYWORDS },
    { "event_idl_path", (PyCFunction)_wrap_bonobo_event_idl_path, METH_VARARGS|METH_KEYWORDS },
    { "debug_shutdown", (PyCFunction)_wrap_bonobo_debug_shutdown, METH_NOARGS },
    { "main", (PyCFunction)_wrap_bonobo_main, METH_NOARGS },
    { "main_quit", (PyCFunction)_wrap_bonobo_main_quit, METH_NOARGS },
    { "activate", (PyCFunction)_wrap_bonobo_activate, METH_NOARGS },
    { "orb", (PyCFunction)_wrap_bonobo_orb, METH_NOARGS },
    { "poa", (PyCFunction)_wrap_bonobo_poa, METH_NOARGS },
    { "poa_manager", (PyCFunction)_wrap_bonobo_poa_manager, METH_NOARGS },
    { "get_object", (PyCFunction)_wrap_bonobo_get_object, METH_VARARGS|METH_KEYWORDS },
    { "moniker_client_new_from_name", (PyCFunction)_wrap_bonobo_moniker_client_new_from_name, METH_VARARGS|METH_KEYWORDS },
    { "moniker_client_get_name", (PyCFunction)_wrap_bonobo_moniker_client_get_name, METH_VARARGS|METH_KEYWORDS },
    { "moniker_client_resolve_default", (PyCFunction)_wrap_bonobo_moniker_client_resolve_default, METH_VARARGS|METH_KEYWORDS },
    { "moniker_client_equal", (PyCFunction)_wrap_bonobo_moniker_client_equal, METH_VARARGS|METH_KEYWORDS },
    { "moniker_util_get_parent_name", (PyCFunction)_wrap_bonobo_moniker_util_get_parent_name, METH_VARARGS|METH_KEYWORDS },
    { "moniker_util_qi_return", (PyCFunction)_wrap_bonobo_moniker_util_qi_return, METH_VARARGS|METH_KEYWORDS },
    { "moniker_util_seek_std_separator", (PyCFunction)_wrap_bonobo_moniker_util_seek_std_separator, METH_VARARGS|METH_KEYWORDS },
    { "moniker_util_escape", (PyCFunction)_wrap_bonobo_moniker_util_escape, METH_VARARGS|METH_KEYWORDS },
    { "moniker_util_unescape", (PyCFunction)_wrap_bonobo_moniker_util_unescape, METH_VARARGS|METH_KEYWORDS },
    { "url_register", (PyCFunction)_wrap_bonobo_url_register, METH_VARARGS|METH_KEYWORDS },
    { "url_unregister", (PyCFunction)_wrap_bonobo_url_unregister, METH_VARARGS|METH_KEYWORDS },
    { "url_lookup", (PyCFunction)_wrap_bonobo_url_lookup, METH_VARARGS|METH_KEYWORDS },
    { "object_dup_ref", (PyCFunction)_wrap_bonobo_object_dup_ref, METH_VARARGS|METH_KEYWORDS },
    { "object_release_unref", (PyCFunction)_wrap_bonobo_object_release_unref, METH_VARARGS|METH_KEYWORDS },
    { "object_from_stream", (PyCFunction)_wrap_bonobo_object_from_stream, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_string", (PyCFunction)_wrap_bonobo_pbclient_get_string, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_string", (PyCFunction)_wrap_bonobo_pbclient_get_default_string, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_short", (PyCFunction)_wrap_bonobo_pbclient_get_short, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_short", (PyCFunction)_wrap_bonobo_pbclient_get_default_short, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_ushort", (PyCFunction)_wrap_bonobo_pbclient_get_ushort, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_ushort", (PyCFunction)_wrap_bonobo_pbclient_get_default_ushort, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_long", (PyCFunction)_wrap_bonobo_pbclient_get_long, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_long", (PyCFunction)_wrap_bonobo_pbclient_get_default_long, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_ulong", (PyCFunction)_wrap_bonobo_pbclient_get_ulong, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_ulong", (PyCFunction)_wrap_bonobo_pbclient_get_default_ulong, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_float", (PyCFunction)_wrap_bonobo_pbclient_get_float, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_float", (PyCFunction)_wrap_bonobo_pbclient_get_default_float, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_double", (PyCFunction)_wrap_bonobo_pbclient_get_double, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_double", (PyCFunction)_wrap_bonobo_pbclient_get_default_double, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_boolean", (PyCFunction)_wrap_bonobo_pbclient_get_boolean, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_boolean", (PyCFunction)_wrap_bonobo_pbclient_get_default_boolean, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_char", (PyCFunction)_wrap_bonobo_pbclient_get_char, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_char", (PyCFunction)_wrap_bonobo_pbclient_get_default_char, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_value", (PyCFunction)_wrap_bonobo_pbclient_get_value, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_default_value", (PyCFunction)_wrap_bonobo_pbclient_get_default_value, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_string", (PyCFunction)_wrap_bonobo_pbclient_set_string, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_short", (PyCFunction)_wrap_bonobo_pbclient_set_short, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_ushort", (PyCFunction)_wrap_bonobo_pbclient_set_ushort, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_long", (PyCFunction)_wrap_bonobo_pbclient_set_long, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_ulong", (PyCFunction)_wrap_bonobo_pbclient_set_ulong, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_float", (PyCFunction)_wrap_bonobo_pbclient_set_float, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_double", (PyCFunction)_wrap_bonobo_pbclient_set_double, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_boolean", (PyCFunction)_wrap_bonobo_pbclient_set_boolean, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_char", (PyCFunction)_wrap_bonobo_pbclient_set_char, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_set_value", (PyCFunction)_wrap_bonobo_pbclient_set_value, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_doc_title", (PyCFunction)_wrap_bonobo_pbclient_get_doc_title, METH_VARARGS|METH_KEYWORDS },
    { "pbclient_get_doc", (PyCFunction)_wrap_bonobo_pbclient_get_doc, METH_VARARGS|METH_KEYWORDS },
    { "storage_mem_create", (PyCFunction)_wrap_bonobo_storage_mem_create, METH_NOARGS },
    { "stream_client_get_length", (PyCFunction)_wrap_bonobo_stream_client_get_length, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

/* intialise stuff extension classes */
void
pybonobo_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }


#line 18 "bonobo.override"
    init_pyorbit();

#line 2391 "bonobo.c"
    pygobject_register_class(d, "BonoboObject", BONOBO_TYPE_OBJECT, &PyBonoboObject_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "BonoboGenericFactory", BONOBO_TYPE_GENERIC_FACTORY, &PyBonoboGenericFactory_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboItemHandler", BONOBO_TYPE_ITEM_HANDLER, &PyBonoboItemHandler_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboListener", BONOBO_TYPE_LISTENER, &PyBonoboListener_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboMoniker", BONOBO_TYPE_MONIKER, &PyBonoboMoniker_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboMonikerSimple", BONOBO_TYPE_MONIKER_SIMPLE, &PyBonoboMonikerSimple_Type, Py_BuildValue("(O)", &PyBonoboMoniker_Type));
    pygobject_register_class(d, "BonoboPersist", BONOBO_TYPE_PERSIST, &PyBonoboPersist_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboPersistFile", BONOBO_TYPE_PERSIST_FILE, &PyBonoboPersistFile_Type, Py_BuildValue("(O)", &PyBonoboPersist_Type));
    pygobject_register_class(d, "BonoboPersistStream", BONOBO_TYPE_PERSIST_STREAM, &PyBonoboPersistStream_Type, Py_BuildValue("(O)", &PyBonoboPersist_Type));
    pygobject_register_class(d, "BonoboPropertyBag", BONOBO_TYPE_PROPERTY_BAG, &PyBonoboPropertyBag_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
    pygobject_register_class(d, "BonoboStreamMem", BONOBO_TYPE_STREAM_MEM, &PyBonoboStreamMem_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
}
