/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "gnome.override"
#include <Python.h>

#include "pygobject.h"
#include <libgnome/libgnome.h>
#include <libgnome/libgnometypebuiltins.h>
#line 14 "gnome.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyGnomeProgram_Type;


/* ----------- GnomeProgram ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_gnome_program_parse_args(PyGObject *self)
{
    gnome_program_parse_args(GNOME_PROGRAM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_program_postinit(PyGObject *self)
{
    gnome_program_postinit(GNOME_PROGRAM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeProgram_methods[] = {
    { "parse_args", (PyCFunction)_wrap_gnome_program_parse_args, METH_NOARGS },
    { "postinit", (PyCFunction)_wrap_gnome_program_postinit, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeProgram_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.Program",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeProgram_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_gnome_config_set_translated_string_(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "value", "priv", NULL };
    char *path, *value;
    int priv;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssi:config_set_translated_string_", kwlist, &path, &value, &priv))
        return NULL;
    gnome_config_set_translated_string_(path, value, priv);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_config_set_int_(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "value", "priv", NULL };
    char *path;
    int value, priv;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sii:config_set_int_", kwlist, &path, &value, &priv))
        return NULL;
    gnome_config_set_int_(path, value, priv);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_config_set_float_(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "value", "priv", NULL };
    char *path;
    double value;
    int priv;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sdi:config_set_float_", kwlist, &path, &value, &priv))
        return NULL;
    gnome_config_set_float_(path, value, priv);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_config_set_bool_(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "value", "priv", NULL };
    char *path;
    int value, priv;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sii:config_set_bool_", kwlist, &path, &value, &priv))
        return NULL;
    gnome_config_set_bool_(path, value, priv);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_config_drop_all(PyObject *self)
{
    gnome_config_drop_all();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_config_sync(PyObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_config_sync();
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_config_sync_file_(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "priv", NULL };
    char *path;
    int priv, ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:config_sync_file_", kwlist, &path, &priv))
        return NULL;
    ret = gnome_config_sync_file_(path, priv);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_config_pop_prefix(PyObject *self)
{
    gnome_config_pop_prefix();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_execute_shell(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dir", "commandline", NULL };
    char *dir, *commandline;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:execute_shell", kwlist, &dir, &commandline))
        return NULL;
    ret = gnome_execute_shell(dir, commandline);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_execute_shell_fds(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dir", "commandline", "close_fds", NULL };
    char *dir, *commandline;
    int close_fds, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssi:execute_shell_fds", kwlist, &dir, &commandline, &close_fds))
        return NULL;
    ret = gnome_execute_shell_fds(dir, commandline, close_fds);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_execute_terminal_shell(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dir", "commandline", NULL };
    char *dir, *commandline;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:execute_terminal_shell", kwlist, &dir, &commandline))
        return NULL;
    ret = gnome_execute_terminal_shell(dir, commandline);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_execute_terminal_shell_fds(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dir", "commandline", "close_fds", NULL };
    char *dir, *commandline;
    int close_fds, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssi:execute_terminal_shell_fds", kwlist, &dir, &commandline, &close_fds))
        return NULL;
    ret = gnome_execute_terminal_shell_fds(dir, commandline, close_fds);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_gconf_get_app_settings_relative(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "program", "subkey", NULL };
    PyGObject *program;
    char *subkey;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:gconf_get_app_settings_relative", kwlist, &PyGnomeProgram_Type, &program, &subkey))
        return NULL;
    ret = gnome_gconf_get_app_settings_relative(GNOME_PROGRAM(program->obj), subkey);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_help_display(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "doc_name", "link_id", NULL };
    char *doc_name, *link_id;
    int ret;
    GError *error = NULL;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:help_display", kwlist, &doc_name, &link_id))
        return NULL;
    ret = gnome_help_display(doc_name, link_id, &error);
    if (pyg_error_check(&error))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_help_display_with_doc_id(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "program", "doc_id", "file_name", "link_id", NULL };
    PyGObject *program;
    char *doc_id, *file_name, *link_id;
    int ret;
    GError *error = NULL;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sss:help_display_with_doc_id", kwlist, &PyGnomeProgram_Type, &program, &doc_id, &file_name, &link_id))
        return NULL;
    ret = gnome_help_display_with_doc_id(GNOME_PROGRAM(program->obj), doc_id, file_name, link_id, &error);
    if (pyg_error_check(&error))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_help_display_desktop(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "program", "doc_id", "file_name", "link_id", NULL };
    PyGObject *program;
    char *doc_id, *file_name, *link_id;
    int ret;
    GError *error = NULL;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sss:help_display_desktop", kwlist, &PyGnomeProgram_Type, &program, &doc_id, &file_name, &link_id))
        return NULL;
    ret = gnome_help_display_desktop(GNOME_PROGRAM(program->obj), doc_id, file_name, link_id, &error);
    if (pyg_error_check(&error))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_help_display_uri(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "help_uri", NULL };
    char *help_uri;
    int ret;
    GError *error = NULL;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:help_display_uri", kwlist, &help_uri))
        return NULL;
    ret = gnome_help_display_uri(help_uri, &error);
    if (pyg_error_check(&error))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_i18n_push_c_numeric_locale(PyObject *self)
{
    gnome_i18n_push_c_numeric_locale();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_i18n_pop_c_numeric_locale(PyObject *self)
{
    gnome_i18n_pop_c_numeric_locale();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_program_get(PyObject *self)
{
    GnomeProgram *ret;

    ret = gnome_program_get();
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 18 "gnome.override"
static PyObject *
_wrap_gnome_program_init (PyObject *self,
			  PyObject *args,
			  PyObject *kwargs)
{
	static char *kwlist[] = { "app_id", "app_version", NULL };
	gchar *app_id;
	gchar *app_version;
	PyObject *av;
	int argc;
	char **argv;
	int i;
	GnomeModuleInfo moduleinfo = { 0, };
	GnomeProgram *program;

	if (!PyArg_ParseTupleAndKeywords (args, kwargs,
					  "ss:gnome.program_init", kwlist,
					  &app_id, &app_version)) {
		return NULL;
	}
	
	/* get argc and argv */
	av = PySys_GetObject ("argv");
	argc = PyList_Size (av);
	argv = g_new (char *, argc);
	for (i = 0; i < argc; i++) {
		argv[i] = g_strdup (PyString_AsString (PyList_GetItem (av, i)));
	}
	
	moduleinfo.name = app_id;
	moduleinfo.version = app_version;
	
	program = gnome_program_init (app_id, app_version,
				      &moduleinfo,
		                      argc, argv,
		                      NULL);
	
	/* TODO: Check if it's really neccessary to set argc and argv here */
	PySys_SetArgv (argc, argv);
	if (argv != NULL) {
		for (i = 0; i < argc; i++)
			g_free (argv[i]);
		g_free (argv);
	}
	
	if (!program) {
		PyErr_SetString (PyExc_RuntimeError, "could not create GnomeProgram object");
		return NULL;
	}
	
        return pygobject_new ((GObject*)program);
}
#line 435 "gnome.c"


static PyObject *
_wrap_gnome_score_log(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "score", "level", "higher_to_lower_score_order", NULL };
    char *level;
    double score;
    int higher_to_lower_score_order, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "dsi:score_log", kwlist, &score, &level, &higher_to_lower_score_order))
        return NULL;
    ret = gnome_score_log(score, level, higher_to_lower_score_order);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_sound_init(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "hostname", NULL };
    char *hostname;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:sound_init", kwlist, &hostname))
        return NULL;
    gnome_sound_init(hostname);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_sound_shutdown(PyObject *self)
{
    gnome_sound_shutdown();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_sound_sample_load(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "sample_name", "filename", NULL };
    char *sample_name, *filename;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:sound_sample_load", kwlist, &sample_name, &filename))
        return NULL;
    ret = gnome_sound_sample_load(sample_name, filename);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_sound_play(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:sound_play", kwlist, &filename))
        return NULL;
    gnome_sound_play(filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_url_show(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "url", NULL };
    char *url;
    int ret;
    GError *error = NULL;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:url_show", kwlist, &url))
        return NULL;
    ret = gnome_url_show(url, &error);
    if (pyg_error_check(&error))
        return NULL;
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_util_user_shell(PyObject *self)
{
    gchar *ret;

    ret = gnome_util_user_shell();
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_setenv(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "value", "overwrite", NULL };
    char *name, *value;
    int overwrite, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssi:setenv", kwlist, &name, &value, &overwrite))
        return NULL;
    ret = gnome_setenv(name, value, overwrite);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_unsetenv(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:unsetenv", kwlist, &name))
        return NULL;
    gnome_unsetenv(name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_clearenv(PyObject *self)
{
    gnome_clearenv();
    Py_INCREF(Py_None);
    return Py_None;
}

PyMethodDef pygnome_functions[] = {
    { "config_set_translated_string_", (PyCFunction)_wrap_gnome_config_set_translated_string_, METH_VARARGS|METH_KEYWORDS },
    { "config_set_int_", (PyCFunction)_wrap_gnome_config_set_int_, METH_VARARGS|METH_KEYWORDS },
    { "config_set_float_", (PyCFunction)_wrap_gnome_config_set_float_, METH_VARARGS|METH_KEYWORDS },
    { "config_set_bool_", (PyCFunction)_wrap_gnome_config_set_bool_, METH_VARARGS|METH_KEYWORDS },
    { "config_drop_all", (PyCFunction)_wrap_gnome_config_drop_all, METH_NOARGS },
    { "config_sync", (PyCFunction)_wrap_gnome_config_sync, METH_NOARGS },
    { "config_sync_file_", (PyCFunction)_wrap_gnome_config_sync_file_, METH_VARARGS|METH_KEYWORDS },
    { "config_pop_prefix", (PyCFunction)_wrap_gnome_config_pop_prefix, METH_NOARGS },
    { "execute_shell", (PyCFunction)_wrap_gnome_execute_shell, METH_VARARGS|METH_KEYWORDS },
    { "execute_shell_fds", (PyCFunction)_wrap_gnome_execute_shell_fds, METH_VARARGS|METH_KEYWORDS },
    { "execute_terminal_shell", (PyCFunction)_wrap_gnome_execute_terminal_shell, METH_VARARGS|METH_KEYWORDS },
    { "execute_terminal_shell_fds", (PyCFunction)_wrap_gnome_execute_terminal_shell_fds, METH_VARARGS|METH_KEYWORDS },
    { "gconf_get_app_settings_relative", (PyCFunction)_wrap_gnome_gconf_get_app_settings_relative, METH_VARARGS|METH_KEYWORDS },
    { "help_display", (PyCFunction)_wrap_gnome_help_display, METH_VARARGS|METH_KEYWORDS },
    { "help_display_with_doc_id", (PyCFunction)_wrap_gnome_help_display_with_doc_id, METH_VARARGS|METH_KEYWORDS },
    { "help_display_desktop", (PyCFunction)_wrap_gnome_help_display_desktop, METH_VARARGS|METH_KEYWORDS },
    { "help_display_uri", (PyCFunction)_wrap_gnome_help_display_uri, METH_VARARGS|METH_KEYWORDS },
    { "i18n_push_c_numeric_locale", (PyCFunction)_wrap_gnome_i18n_push_c_numeric_locale, METH_NOARGS },
    { "i18n_pop_c_numeric_locale", (PyCFunction)_wrap_gnome_i18n_pop_c_numeric_locale, METH_NOARGS },
    { "program_get", (PyCFunction)_wrap_gnome_program_get, METH_NOARGS },
    { "program_init", (PyCFunction)_wrap_gnome_program_init, METH_VARARGS|METH_KEYWORDS },
    { "score_log", (PyCFunction)_wrap_gnome_score_log, METH_VARARGS|METH_KEYWORDS },
    { "sound_init", (PyCFunction)_wrap_gnome_sound_init, METH_VARARGS|METH_KEYWORDS },
    { "sound_shutdown", (PyCFunction)_wrap_gnome_sound_shutdown, METH_NOARGS },
    { "sound_sample_load", (PyCFunction)_wrap_gnome_sound_sample_load, METH_VARARGS|METH_KEYWORDS },
    { "sound_play", (PyCFunction)_wrap_gnome_sound_play, METH_VARARGS|METH_KEYWORDS },
    { "url_show", (PyCFunction)_wrap_gnome_url_show, METH_VARARGS|METH_KEYWORDS },
    { "util_user_shell", (PyCFunction)_wrap_gnome_util_user_shell, METH_NOARGS },
    { "setenv", (PyCFunction)_wrap_gnome_setenv, METH_VARARGS|METH_KEYWORDS },
    { "unsetenv", (PyCFunction)_wrap_gnome_unsetenv, METH_VARARGS|METH_KEYWORDS },
    { "clearenv", (PyCFunction)_wrap_gnome_clearenv, METH_NOARGS },
    { NULL, NULL, 0 }
};


/* ----------- enums and flags ----------- */

void
pygnome_add_constants(PyObject *module, const gchar *strip_prefix)
{
    pyg_enum_add_constants(module, GNOME_TYPE_HELP_ERROR, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_FILE_DOMAIN, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_TRIGGER_TYPE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_URL_ERROR, strip_prefix);
}

/* intialise stuff extension classes */
void
pygnome_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }


#line 630 "gnome.c"
    pygobject_register_class(d, "GnomeProgram", GNOME_TYPE_PROGRAM, &PyGnomeProgram_Type, Py_BuildValue("(O)", &PyGObject_Type));
}
