/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "nautilus.override"
#include <Python.h>

#include <pygobject.h>
#include <pygtk/pygtk.h>
#include <libnautilus/nautilus-view.h>
#include <libnautilus/nautilus-view-standard-main.h>
#include <pyorbit.h>
#line 16 "nautilus.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkWidget_Type;
#define PyGtkWidget_Type (*_PyGtkWidget_Type)
static PyTypeObject *_PyBonoboObject_Type;
#define PyBonoboObject_Type (*_PyBonoboObject_Type)
static PyTypeObject *_PyBonoboControl_Type;
#define PyBonoboControl_Type (*_PyBonoboControl_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyNautilusView_Type;


/* ----------- NautilusView ----------- */

static int
_wrap_nautilus_view_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", NULL };
    PyGObject *widget;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:NautilusView.__init__", kwlist, &PyGtkWidget_Type, &widget))
        return -1;
    self->obj = (GObject *)nautilus_view_new(GTK_WIDGET(widget->obj));

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create NautilusView object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_nautilus_view_get_bonobo_control(PyGObject *self)
{
    BonoboControl *ret;

    ret = nautilus_view_get_bonobo_control(NAUTILUS_VIEW(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_nautilus_view_open_location_in_this_window(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "location_uri", NULL };
    char *location_uri;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:NautilusView.open_location_in_this_window", kwlist, &location_uri))
        return NULL;
    nautilus_view_open_location_in_this_window(NAUTILUS_VIEW(self->obj), location_uri);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_open_location_prefer_existing_window(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "location_uri", NULL };
    char *location_uri;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:NautilusView.open_location_prefer_existing_window", kwlist, &location_uri))
        return NULL;
    nautilus_view_open_location_prefer_existing_window(NAUTILUS_VIEW(self->obj), location_uri);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_report_status(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "status", NULL };
    char *status;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:NautilusView.report_status", kwlist, &status))
        return NULL;
    nautilus_view_report_status(NAUTILUS_VIEW(self->obj), status);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_report_load_underway(PyGObject *self)
{
    nautilus_view_report_load_underway(NAUTILUS_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_report_load_progress(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "fraction_done", NULL };
    double fraction_done;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "d:NautilusView.report_load_progress", kwlist, &fraction_done))
        return NULL;
    nautilus_view_report_load_progress(NAUTILUS_VIEW(self->obj), fraction_done);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_report_load_complete(PyGObject *self)
{
    nautilus_view_report_load_complete(NAUTILUS_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_report_load_failed(PyGObject *self)
{
    nautilus_view_report_load_failed(NAUTILUS_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "title", NULL };
    char *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:NautilusView.set_title", kwlist, &title))
        return NULL;
    nautilus_view_set_title(NAUTILUS_VIEW(self->obj), title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_go_back(PyGObject *self)
{
    nautilus_view_go_back(NAUTILUS_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_set_up_ui(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "datadir", "ui_xml_file_name", "application_name", NULL };
    char *datadir, *ui_xml_file_name, *application_name;
    BonoboUIComponent *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sss:NautilusView.set_up_ui", kwlist, &datadir, &ui_xml_file_name, &application_name))
        return NULL;
    ret = nautilus_view_set_up_ui(NAUTILUS_VIEW(self->obj), datadir, ui_xml_file_name, application_name);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_nautilus_view_get_ambient_properties(PyGObject *self)
{
    CORBA_Environment opt_ev;
    Bonobo_PropertyBag ret;

    CORBA_exception_init(&opt_ev);
    ret = nautilus_view_get_ambient_properties(NAUTILUS_VIEW(self->obj), &opt_ev);
    if (pyorbit_check_ex(&opt_ev))
        return NULL;
    if (ret != CORBA_OBJECT_NIL)
        return pycorba_object_new(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_nautilus_view_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", NULL };
    PyGObject *widget;
    NautilusView *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:NautilusView.construct", kwlist, &PyGtkWidget_Type, &widget))
        return NULL;
    ret = nautilus_view_construct(NAUTILUS_VIEW(self->obj), GTK_WIDGET(widget->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_nautilus_view_construct_from_bonobo_control(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bonobo_control", NULL };
    PyGObject *bonobo_control;
    NautilusView *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:NautilusView.construct_from_bonobo_control", kwlist, &PyBonoboControl_Type, &bonobo_control))
        return NULL;
    ret = nautilus_view_construct_from_bonobo_control(NAUTILUS_VIEW(self->obj), BONOBO_CONTROL(bonobo_control->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyNautilusView_methods[] = {
    { "get_bonobo_control", (PyCFunction)_wrap_nautilus_view_get_bonobo_control, METH_NOARGS },
    { "open_location_in_this_window", (PyCFunction)_wrap_nautilus_view_open_location_in_this_window, METH_VARARGS|METH_KEYWORDS },
    { "open_location_prefer_existing_window", (PyCFunction)_wrap_nautilus_view_open_location_prefer_existing_window, METH_VARARGS|METH_KEYWORDS },
    { "report_status", (PyCFunction)_wrap_nautilus_view_report_status, METH_VARARGS|METH_KEYWORDS },
    { "report_load_underway", (PyCFunction)_wrap_nautilus_view_report_load_underway, METH_NOARGS },
    { "report_load_progress", (PyCFunction)_wrap_nautilus_view_report_load_progress, METH_VARARGS|METH_KEYWORDS },
    { "report_load_complete", (PyCFunction)_wrap_nautilus_view_report_load_complete, METH_NOARGS },
    { "report_load_failed", (PyCFunction)_wrap_nautilus_view_report_load_failed, METH_NOARGS },
    { "set_title", (PyCFunction)_wrap_nautilus_view_set_title, METH_VARARGS|METH_KEYWORDS },
    { "go_back", (PyCFunction)_wrap_nautilus_view_go_back, METH_NOARGS },
    { "set_up_ui", (PyCFunction)_wrap_nautilus_view_set_up_ui, METH_VARARGS|METH_KEYWORDS },
    { "get_ambient_properties", (PyCFunction)_wrap_nautilus_view_get_ambient_properties, METH_NOARGS },
    { "construct", (PyCFunction)_wrap_nautilus_view_construct, METH_VARARGS|METH_KEYWORDS },
    { "construct_from_bonobo_control", (PyCFunction)_wrap_nautilus_view_construct_from_bonobo_control, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyNautilusView_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.nautilus.View",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyNautilusView_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_nautilus_view_new,		/* tp_init */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_nautilus_view_new_from_bonobo_control(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "bonobo_control", NULL };
    PyGObject *bonobo_control;
    NautilusView *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:nautilus_view_new_from_bonobo_control", kwlist, &PyBonoboControl_Type, &bonobo_control))
        return NULL;
    ret = nautilus_view_new_from_bonobo_control(BONOBO_CONTROL(bonobo_control->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 26 "nautilus.override"
	
BonoboObject * 
nautilus_view_create_function (const char *iid, void *user_data)
{
    PyObject  *data = (PyObject*)user_data;
    PyObject  *func;
    PyGObject *retval;
	
    func = PyTuple_GetItem (data, 0);
	
    retval = (PyGObject*)PyObject_CallFunction (func, "s", 
						PyString_FromString (iid));

    if (PyErr_Occurred ()) {
	PyErr_Print ();
	return NULL;
    }

    return BONOBO_OBJECT (retval->obj);
}

static PyObject*
_wrap_nautilus_view_standard_main (PyGObject *self,
				   PyObject  *args,
				   PyObject  *kwargs)
{
    static char *kwlist[] = { "executable_name", "version", "factory_iid", 
			          "view_iid", "create_function", NULL };
    char *executable_name;
    char *version;
    char *factory_iid;
    char *view_iid;
    PyObject *create_function;
    PyObject *av;
    int argc;
    char **argv;
    int i;
    PyObject *data;
    int retval;
	
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "ssssO:NautilusView.__init__",
				     kwlist, 
				     &executable_name, &version,
				     &factory_iid, &view_iid,
				     &create_function))
	return NULL;
	
    if (!PyCallable_Check(create_function)) {
	PyErr_SetString(PyExc_TypeError, "fifth arg not callable");
	return NULL;
    }
	
    /* get argc and argv */
    av = PySys_GetObject("argv");
    argc = PyList_Size(av);
    argv = g_new(char *, argc);
    for (i = 0; i < argc; i++)
	argv[i] = g_strdup(PyString_AsString(PyList_GetItem(av, i)));

    data = Py_BuildValue ("(O)", create_function);
	
    retval = nautilus_view_standard_main (executable_name,
					  version,
					  NULL,
					  NULL,
					  argc,
					  argv,
					  factory_iid,
					  view_iid,
					  nautilus_view_create_function,
					  NULL,
					  data);
				     
    if (argv != NULL) {
	for (i = 0; i < argc; i++)
	    g_free(argv[i]);
	g_free(argv);
    }
	
    return PyInt_FromLong (retval);
}
#line 379 "nautilus.c"


PyMethodDef pynautilus_functions[] = {
    { "nautilus_view_new_from_bonobo_control", (PyCFunction)_wrap_nautilus_view_new_from_bonobo_control, METH_VARARGS|METH_KEYWORDS },
    { "view_standard_main", (PyCFunction)_wrap_nautilus_view_standard_main, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

/* intialise stuff extension classes */
void
pynautilus_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("bonobo")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyBonoboObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Object");
    } else {
        Py_FatalError("could not import bonobo");
        return;
    }
    if ((module = PyImport_ImportModule("bonobo.ui")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyBonoboControl_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Control");
    } else {
        Py_FatalError("could not import bonobo.ui");
        return;
    }
    if ((module = PyImport_ImportModule("gtk._gtk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGtkWidget_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Widget");
    } else {
        Py_FatalError("could not import gtk._gtk");
        return;
    }


#line 428 "nautilus.c"
    pygobject_register_class(d, "NautilusView", NAUTILUS_TYPE_VIEW, &PyNautilusView_Type, Py_BuildValue("(O)", &PyBonoboObject_Type));
}
